Index: /extensions/CryptograPHP/admin.php
===================================================================
--- /extensions/CryptograPHP/admin.php	(revision 12616)
+++ /extensions/CryptograPHP/admin.php	(revision 12617)
@@ -2,26 +2,85 @@
 if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
 
+$conf['cryptographp'] = unserialize($conf['cryptographp']);
 load_language('plugin.lang', CRYPTO_PATH);
-$conf['cryptographp_theme'] = explode(',', $conf['cryptographp_theme']);
 
 if ( isset($_POST['submit']))
 {
-  $conf['cryptographp_theme'] = array(
-    $_POST['cryptographp_theme'],
-    $_POST['comments_action'],
+  $conf['cryptographp'] = array(
+    'comments_action' => $_POST['comments_action'],
+    'theme'           => $_POST['theme'],
+    'captcha_type'    => $_POST['captcha_type'],
+    'case_sensitive'  => $conf['cryptographp']['case_sensitive'], //not used, problem with some fonts
+    'width'           => (int)$_POST['width'], 
+    'height'          => (int)$_POST['height'],
+    'perturbation'    => (float)$_POST['perturbation'],
+    'image_bg_color'  => $_POST['image_bg_color'],
+    'code_length'     => (int)$_POST['code_length'],
+    'text_color'      => $_POST['text_color'],
+    'num_lines'       => (float)$_POST['num_lines'],
+    'line_color'      => $_POST['line_color'],
+    'noise_level'     => (float)$_POST['noise_level'],
+    'noise_color'     => $_POST['noise_color'],
+    'ttf_file'        => $_POST['ttf_file'],
     );
-  conf_update_param('cryptographp_theme', implode(',', $conf['cryptographp_theme']));
+  
+  conf_update_param('cryptographp', serialize($conf['cryptographp']));
   array_push($page['infos'], l10n('Information data registered in database'));
 }
 
-$template->set_filename('plugin_admin_content', dirname(__FILE__).'/admin.tpl');
+$presets = array(
+  'bluenoise' => array('perturbation'=>0.25, 'image_bg_color'=>'ffffff', 'text_color'=>'0000ff', 'num_lines'=>2, 'line_color'=>'0000ff', 'noise_level'=>2, 'noise_color'=>'0000ff', 'ttf_file'=>'AlteHassGroteskB'),
+  'gray' => array('perturbation'=>1, 'image_bg_color'=>'ffffff', 'text_color'=>'8a8a8a', 'num_lines'=>2, 'line_color'=>'8a8a8a', 'noise_level'=>0.1, 'noise_color'=>'8a8a8a', 'ttf_file'=>'TopSecret'),
+  'xcolor' => array('perturbation'=>0.5, 'image_bg_color'=>'ffffff', 'text_color'=>'random', 'num_lines'=>1, 'line_color'=>'ffffff', 'noise_level'=>2, 'noise_color'=>'ffffff', 'ttf_file'=>'Dread'),
+  'pencil' => array('perturbation'=>0.8, 'image_bg_color'=>'9e9e9e', 'text_color'=>'363636', 'num_lines'=>0, 'line_color'=>'ffffff', 'noise_level'=>0, 'noise_color'=>'ffffff', 'ttf_file'=>'AllStar'),
+  );
+  
+function list_fonts($dir)
+{
+  $dir = rtrim($dir, '/');
+  $dh = opendir($dir);
+  $fonts = array();
+  
+  while (($file = readdir($dh)) !== false )
+  {
+    if ($file !== '.' && $file !== '..') $fonts[] = str_replace('.ttf', null, $file);
+  }
+  
+  closedir($dh);
+  return $fonts;
+}
+
+function presets_to_js($presets)
+{
+  $out = null;
+  
+  foreach ($presets as $name => $param)
+  {
+    $out.= '
+function apply_'.$name.'() {
+  $("input[name=perturbation]").val("'.$param['perturbation'].'");
+  $("input[name=image_bg_color]").val("'.$param['image_bg_color'].'");
+  $("input[name=text_color]").val("'.$param['text_color'].'");
+  $("input[name=num_lines]").val("'.$param['num_lines'].'");
+  $("input[name=line_color]").val("'.$param['line_color'].'");
+  $("input[name=noise_level]").val("'.$param['noise_level'].'");
+  $("input[name=noise_color]").val("'.$param['noise_color'].'");
+  $("input[name=ttf_file]").val(["'.$param['ttf_file'].'"]);
+
+}';
+  }
+   
+  return $out;
+}
+
+$template->set_filename('plugin_admin_content', dirname(__FILE__).'/template/admin.tpl');
 
 $template->assign(array(
-  'cryptographp_theme' => $conf['cryptographp_theme'][0],
-  'comments_action' => $conf['cryptographp_theme'][1],
-  'available_themes' => array('cryptographp', 'bluenoise', 'gray', 'pencil', 'xcolor'),
+  'crypto' => $conf['cryptographp'],
+  'fonts' => list_fonts(CRYPTO_PATH.'securimage/fonts'),
+  'presets' => array_keys($presets),
+  'PRESETS_FUNC' => presets_to_js($presets),
   'CRYPTO_PATH' => CRYPTO_PATH,
-  )
-);
+  ));
 
 $template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');
Index: /extensions/CryptograPHP/include/category.inc.php
===================================================================
--- /extensions/CryptograPHP/include/category.inc.php	(revision 12616)
+++ /extensions/CryptograPHP/include/category.inc.php	(revision 12617)
@@ -1,8 +1,4 @@
 <?php
-
 if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
-
-$cryptinstall = CRYPTO_PATH.'cryptographp/cryptographp.fct.php';
-include($cryptinstall);
 
 add_event_handler('loc_begin_index', 'add_crypto');
@@ -11,19 +7,25 @@
 function add_crypto()
 {
-  global $template, $conf;
+  global $template;
   
   if (!is_a_guest()) return;
   
   $template->set_prefilter('comments_on_albums', 'prefilter_crypto');
-  $template->assign('CAPTCHA', dsp_crypt($conf['cryptographp_theme'][0].'.cfg.php',1));
 }
 
 function prefilter_crypto($content, $smarty)
 {
-  load_language('plugin.lang', CRYPTO_PATH);
+  global $conf;
   
   $search = '<input type="hidden" name="key" value="{$comment_add.KEY}">';
   $replace = $search.'
-  <label>{$CAPTCHA}<input type="text" name="code"></label>';
+  <label>
+    <img id="captcha" src="'.CRYPTO_PATH.'securimage/securimage_show.php" alt="CAPTCHA Image">
+    <a href="#" onclick="document.getElementById(\'captcha\').src = \''.CRYPTO_PATH.'securimage/securimage_show.php?\' + Math.random(); return false">
+      <img src="'.CRYPTO_PATH.'template/refresh.png"></a>
+    <br>{\''.($conf['cryptographp']['captcha_type']=='string'?'Enter code':'Solve equation').'\'|@translate} :
+    <input type="text" name="captcha_code" size="'.($conf['cryptographp']['code_length']+1).'" maxlength="'.$conf['cryptographp']['code_length'].'" />
+    
+  </label>';
 
   return str_replace($search, $replace, $content);
@@ -32,21 +34,20 @@
 function check_crypto($action, $comment)
 {
-  global $conf, $user;
+  global $conf;
   
-  $my_action = ($conf['cryptographp_theme'][1] == 'reject') ? 'reject':'moderate';
+  include_once(CRYPTO_PATH.'securimage/securimage.php');
+  $securimage = new Securimage();
 
-  if ($action == 'reject' OR $action == $my_action OR !is_a_guest())
+  if ( $action == 'reject' or $action == $conf['cryptographp']['comments_action'] or !is_a_guest() )
   {
     return $action;
   }
 
-  if (!chk_crypt($_POST['code']))
+  if ($securimage->check($_POST['captcha_code']) == false)
   {
-    return $my_action;
+    return $conf['cryptographp']['comments_action'];
   }
-  else
-  {
-    return $action;
-  }
+
+  return $action;
 }
 
Index: /extensions/CryptograPHP/include/contactform.inc.php
===================================================================
--- /extensions/CryptograPHP/include/contactform.inc.php	(revision 12616)
+++ /extensions/CryptograPHP/include/contactform.inc.php	(revision 12617)
@@ -1,8 +1,4 @@
 <?php
-
 if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
-
-$cryptinstall = CRYPTO_PATH.'cryptographp/cryptographp.fct.php';
-include($cryptinstall);
 
 add_event_handler('display_contactform', 'add_crypto');
@@ -11,14 +7,15 @@
 function add_crypto()
 {
-  global $template, $conf;
+  global $template;
 
   if (!is_a_guest()) return;
 
   $template->set_prefilter('cf_form', 'prefilter_crypto');
-  $template->assign('CAPTCHA', dsp_crypt($conf['cryptographp_theme'][0].'.cfg.php',1));
 }
 
 function prefilter_crypto($content, $smarty)
 {
+  global $conf;
+  
   $search = '
       <tr>
@@ -26,8 +23,14 @@
         <td class="contact-form-right"><input class="submit" type="submit" value="{\'cf_submit\'|@translate}"></td>
       </tr>';
-  $replace = '
+  $replace = '     
     <tr>
-      <td class="contact-form-left" style="vertical-align:top;">{\'Antibot test\'|@translate}</td>
-      <td class="contact-form-right"><input type="text" name="code"> <span style="vertical-align:top;">{$CAPTCHA}</span></td>
+      <td class="contact-form-left" style="vertical-align:top;">
+        {\''.($conf['cryptographp']['captcha_type']=='string'?'Enter code':'Solve equation').'\'|@translate}
+        <img id="captcha" src="'.CRYPTO_PATH.'securimage/securimage_show.php" alt="CAPTCHA Image">
+      </td>
+      <td class="contact-form-right"><input type="text" name="captcha_code" size="'.($conf['cryptographp']['code_length']+1).'" maxlength="'.$conf['cryptographp']['code_length'].'" />
+        <a href="#" onclick="document.getElementById(\'captcha\').src = \''.CRYPTO_PATH.'securimage/securimage_show.php?\' + Math.random(); return false">
+          <img src="'.CRYPTO_PATH.'template/refresh.png"></a>
+      </td>
     </tr>'
   ."\n".$search;
@@ -39,8 +42,10 @@
 {
   if (!is_a_guest()) return $infos;
-
-  if (!chk_crypt($_POST['code']))
+  
+  include_once(CRYPTO_PATH.'securimage/securimage.php');
+  $securimage = new Securimage();
+  
+  if ($securimage->check($_POST['captcha_code']) == false)
   {
-    load_language('plugin.lang', CRYPTO_PATH);
     array_push($infos['errors'], l10n('Invalid Captcha'));
   }
Index: /extensions/CryptograPHP/include/picture.inc.php
===================================================================
--- /extensions/CryptograPHP/include/picture.inc.php	(revision 12616)
+++ /extensions/CryptograPHP/include/picture.inc.php	(revision 12617)
@@ -1,29 +1,31 @@
 <?php
-
 if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
 
-$cryptinstall = CRYPTO_PATH.'cryptographp/cryptographp.fct.php';
-include($cryptinstall);
-
-add_event_handler('loc_begin_picture', 'add_crypto');
+add_event_handler('loc_end_picture', 'add_crypto');
 add_event_handler('user_comment_check', 'check_crypto', EVENT_HANDLER_PRIORITY_NEUTRAL, 2);
 
 function add_crypto()
 {
-  global $template, $conf;
+  global $template;
   
   if (!is_a_guest()) return;
   
   $template->set_prefilter('picture', 'prefilter_crypto');
-  $template->assign('CAPTCHA', dsp_crypt($conf['cryptographp_theme'][0].'.cfg.php',1));
 }
 
 function prefilter_crypto($content, $smarty)
 {
-  load_language('plugin.lang', CRYPTO_PATH);
+  global $conf;
   
   $search = '<input type="hidden" name="key" value="{$comment_add.KEY}">';
   $replace = $search.'
-  <label>{$CAPTCHA}<input type="text" name="code"></label>';
+  <label>
+    <img id="captcha" src="'.CRYPTO_PATH.'securimage/securimage_show.php" alt="CAPTCHA Image">
+    <a href="#" onclick="document.getElementById(\'captcha\').src = \''.CRYPTO_PATH.'securimage/securimage_show.php?\' + Math.random(); return false">
+      <img src="'.CRYPTO_PATH.'template/refresh.png"></a>
+    <br>{\''.($conf['cryptographp']['captcha_type']=='string'?'Enter code':'Solve equation').'\'|@translate} :
+    <input type="text" name="captcha_code" size="'.($conf['cryptographp']['code_length']+1).'" maxlength="'.$conf['cryptographp']['code_length'].'" />
+    
+  </label>';
 
   return str_replace($search, $replace, $content);
@@ -32,21 +34,20 @@
 function check_crypto($action, $comment)
 {
-  global $conf, $user;
+  global $conf;
   
-  $my_action = ($conf['cryptographp_theme'][1] == 'reject') ? 'reject':'moderate';
+  include_once(CRYPTO_PATH.'securimage/securimage.php');
+  $securimage = new Securimage();
 
-  if ($action == 'reject' OR $action == $my_action OR !is_a_guest())
+  if ( $action == 'reject' or $action == $conf['cryptographp']['comments_action'] or !is_a_guest() )
   {
     return $action;
   }
 
-  if (!chk_crypt($_POST['code']))
+  if ($securimage->check($_POST['captcha_code']) == false)
   {
-    return $my_action;
+    return $conf['cryptographp']['comments_action'];
   }
-  else
-  {
-    return $action;
-  }
+
+  return $action;
 }
 
Index: /extensions/CryptograPHP/include/register.inc.php
===================================================================
--- /extensions/CryptograPHP/include/register.inc.php	(revision 12616)
+++ /extensions/CryptograPHP/include/register.inc.php	(revision 12617)
@@ -1,8 +1,4 @@
 <?php
-
 if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
-
-$cryptinstall = CRYPTO_PATH.'cryptographp/cryptographp.fct.php';
-include($cryptinstall);
 
 add_event_handler('loc_end_page_header', 'add_crypto');
@@ -11,37 +7,40 @@
 function add_crypto()
 {
-  global $template, $conf;
+  global $template;
 
   $template->set_prefilter('register', 'prefilter_crypto');
-  $template->assign('CAPTCHA', dsp_crypt($conf['cryptographp_theme'][0].'.cfg.php',1));
 }
 
 function prefilter_crypto($content, $smarty)
 {
-  load_language('plugin.lang', CRYPTO_PATH);
+  global $conf;
   
-  $search = '<p class="bottomButtons">';
+  $search = '#\<\/ul\>(.{0,10})\<\/fieldset\>(.{0,10})\<p class\=\"bottomButtons\"\>#is';
   $replace = '
-  <fieldset>
-    <legend>{\'Antibot test\'|@translate}</legend>
-    <ul>
       <li>
         <span class="property">
-          <label>{$CAPTCHA}</label>
+          <label><img id="captcha" src="'.CRYPTO_PATH.'securimage/securimage_show.php" alt="CAPTCHA Image"></label>
         </span>
-        <input type="text" name="code">
+        <b>{\''.($conf['cryptographp']['captcha_type']=='string'?'Enter code':'Solve equation').'\'|@translate} :</b><br>
+        <input type="text" name="captcha_code" size="'.($conf['cryptographp']['code_length']+1).'" maxlength="'.$conf['cryptographp']['code_length'].'" />
+        <a href="#" onclick="document.getElementById(\'captcha\').src = \''.CRYPTO_PATH.'securimage/securimage_show.php?\' + Math.random(); return false">
+          <img src="'.CRYPTO_PATH.'template/refresh.png"></a>
       </li>
-    </ul>
-  </fieldset>'
-."\n".$search;
+  </ul>
 
-  return str_replace($search, $replace, $content);
+  </fieldset>
+
+  <p class="bottomButtons">';
+
+  return preg_replace($search, $replace, $content);
 }
 
 function check_crypto($errors)
 {
-  if (!chk_crypt($_POST['code']))
+  include_once(CRYPTO_PATH.'securimage/securimage.php');
+  $securimage = new Securimage();
+  
+  if ($securimage->check($_POST['captcha_code']) == false)
   {
-    load_language('plugin.lang', CRYPTO_PATH);
     array_push($errors, l10n('Invalid Captcha'));
   }
Index: /extensions/CryptograPHP/language/cs_CZ/plugin.lang.php
===================================================================
--- /extensions/CryptograPHP/language/cs_CZ/plugin.lang.php	(revision 12616)
+++ /extensions/CryptograPHP/language/cs_CZ/plugin.lang.php	(revision 12617)
@@ -6,5 +6,4 @@
 $lang['Moderate'] = 'Moderovat';
 $lang['No captcha'] = 'Bez captcha kódu';
-$lang['Antibot test'] = 'Antirobot test';
 
 ?>
Index: /extensions/CryptograPHP/language/el_GR/plugin.lang.php
===================================================================
--- /extensions/CryptograPHP/language/el_GR/plugin.lang.php	(revision 12616)
+++ /extensions/CryptograPHP/language/el_GR/plugin.lang.php	(revision 12617)
@@ -3,5 +3,4 @@
 $lang['Invalid Captcha'] = 'Άκυρο Captcha';
 $lang['Captcha theme'] = 'Θέμα Captcha';
-$lang['Antibot test'] = 'Δοκιμή Antibot';
 $lang['Comments action'] = 'Ενέργεια σχολίου';
 $lang['Moderate'] = 'Μέτριο';
Index: /extensions/CryptograPHP/language/en_UK/plugin.lang.php
===================================================================
--- /extensions/CryptograPHP/language/en_UK/plugin.lang.php	(revision 12616)
+++ /extensions/CryptograPHP/language/en_UK/plugin.lang.php	(revision 12617)
@@ -2,9 +2,29 @@
 
 $lang['Invalid Captcha'] = 'Invalid Captcha';
-$lang['Captcha theme'] = 'Captcha theme';
-$lang['Antibot test'] = 'Antibot test';
+$lang['Enter code'] = 'Enter code';
+$lang['Solve equation'] = 'Solve equation';
+
 $lang['Comments action'] = 'Comments action';
 $lang['Moderate'] = 'Moderate';
 $lang['No captcha'] = 'No captcha';
+$lang['Captcha type'] = 'Captcha type';
+$lang['Random string'] = 'Random string';
+$lang['Simple equation'] = 'Simple equation';
+$lang['Case sensitive'] = 'Case sensitive';
+$lang['Code lenght'] = 'Code lenght';
+$lang['good value:'] = 'good value:';
+$lang['Captcha theme'] = 'Captcha theme';
+
+$lang['Perturbation'] = 'Perturbation';
+$lang['range:'] = 'range:';
+$lang['Background color'] = 'Background color';
+$lang['Text color'] = 'Text color';
+$lang['Lines density'] = 'Lines density';
+$lang['Lines color'] = 'Lines color';
+$lang['Noise level'] = 'Noise level';
+$lang['Noise color'] = 'Noise color';
+$lang['Font'] = 'Font';
+$lang['Preview'] = 'Preview';
+$lang['Tip: type "random" on a color field to have a random color'] = 'Tip: type "random" on a color field to have a random color';
 
 ?>
Index: /extensions/CryptograPHP/language/es_ES/plugin.lang.php
===================================================================
--- /extensions/CryptograPHP/language/es_ES/plugin.lang.php	(revision 12616)
+++ /extensions/CryptograPHP/language/es_ES/plugin.lang.php	(revision 12617)
@@ -3,5 +3,4 @@
 $lang['Invalid Captcha'] = 'Captcha no valido';
 $lang['Captcha theme'] = 'Tema del captcha';
-$lang['Antibot test'] = 'Test anti-bots';
 $lang['Comments action'] = 'Acción para los Comentario';
 $lang['Moderate'] = 'Moderar';
Index: /extensions/CryptograPHP/language/fr_FR/plugin.lang.php
===================================================================
--- /extensions/CryptograPHP/language/fr_FR/plugin.lang.php	(revision 12616)
+++ /extensions/CryptograPHP/language/fr_FR/plugin.lang.php	(revision 12617)
@@ -2,9 +2,29 @@
 
 $lang['Invalid Captcha'] = 'Captcha non valide';
-$lang['Captcha theme'] = 'Thème du captcha';
-$lang['Antibot test'] = 'Test anti-bots';
+$lang['Enter code'] = 'Entrez le code';
+$lang['Solve equation'] = 'Resolvez l\'équation';
+
 $lang['Comments action'] = 'Action pour les commentaires';
 $lang['Moderate'] = 'Modérer';
 $lang['No captcha'] = 'Pas de captcha';
+$lang['Captcha type'] = 'Type de captcha';
+$lang['Random string'] = 'Code aléatoire';
+$lang['Simple equation'] = 'Equation simple';
+$lang['Case sensitive'] = 'Sensibilité à la case';
+$lang['Code lenght'] = 'Longueur du code';
+$lang['good value:'] = 'conseillé:';
+$lang['Captcha theme'] = 'Thème du captcha';
+
+$lang['Perturbation'] = 'Perturbation';
+$lang['range:'] = 'plage:';
+$lang['Background color'] = 'Couleur de fond';
+$lang['Text color'] = 'Couleur du texte';
+$lang['Lines density'] = 'Nombre de lignes';
+$lang['Lines color'] = 'Couleur des lignes';
+$lang['Noise level'] = 'Quantité de bruit';
+$lang['Noise color'] = 'Couleur du bruit';
+$lang['Font'] = 'Police';
+$lang['Preview'] = 'Prévisualisation';
+$lang['Tip: type "random" on a color field to have a random color'] = 'Astuce: inscrivez "random" dans un champs de couleur pour avoir une couleur aléatoire';
 
 ?>
Index: /extensions/CryptograPHP/language/hu_HU/plugin.lang.php
===================================================================
--- /extensions/CryptograPHP/language/hu_HU/plugin.lang.php	(revision 12616)
+++ /extensions/CryptograPHP/language/hu_HU/plugin.lang.php	(revision 12617)
@@ -3,5 +3,4 @@
 $lang['Invalid Captcha'] = 'Érvénytelen Captcha';
 $lang['Captcha theme'] = 'Captcha téma';
-$lang['Antibot test'] = 'Antibot teszt';
 $lang['Comments action'] = 'Hozzászólás műveletek';
 $lang['Moderate'] = 'Moderálás';
Index: /extensions/CryptograPHP/language/it_IT/plugin.lang.php
===================================================================
--- /extensions/CryptograPHP/language/it_IT/plugin.lang.php	(revision 12616)
+++ /extensions/CryptograPHP/language/it_IT/plugin.lang.php	(revision 12617)
@@ -3,5 +3,4 @@
 $lang['Invalid Captcha'] = 'Captcha non valido';
 $lang['Captcha theme'] = 'Tema del captcha';
-$lang['Antibot test'] = 'Test Antibot';
 $lang['Comments action'] = 'Azione per i commenti';
 $lang['Moderate'] = 'Moderare';
Index: /extensions/CryptograPHP/language/pl_PL/index.php
===================================================================
--- /extensions/CryptograPHP/language/pl_PL/index.php	(revision 12617)
+++ /extensions/CryptograPHP/language/pl_PL/index.php	(revision 12617)
@@ -0,0 +1,30 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | Piwigo - a PHP based picture gallery                                  |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2008-2010 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+// Recursive call
+$url = '../';
+header( 'Request-URI: '.$url );
+header( 'Content-Location: '.$url );
+header( 'Location: '.$url );
+exit();
+?>
Index: /extensions/CryptograPHP/language/pl_PL/plugin.lang.php
===================================================================
--- /extensions/CryptograPHP/language/pl_PL/plugin.lang.php	(revision 12616)
+++ /extensions/CryptograPHP/language/pl_PL/plugin.lang.php	(revision 12617)
@@ -1,25 +1,4 @@
 <?php
-// +-----------------------------------------------------------------------+
-// | Piwigo - a PHP based photo gallery                                    |
-// +-----------------------------------------------------------------------+
-// | Copyright(C) 2008-2009 Piwigo Team                  http://piwigo.org |
-// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
-// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
-// +-----------------------------------------------------------------------+
-// | This program is free software; you can redistribute it and/or modify  |
-// | it under the terms of the GNU General Public License as published by  |
-// | the Free Software Foundation                                          |
-// |                                                                       |
-// | This program is distributed in the hope that it will be useful, but   |
-// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
-// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
-// | General Public License for more details.                              |
-// |                                                                       |
-// | You should have received a copy of the GNU General Public License     |
-// | along with this program; if not, write to the Free Software           |
-// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
-// | USA.                                                                  |
-// +-----------------------------------------------------------------------+
-$lang['Antibot test'] = 'Test antybotowy';
+
 $lang['Captcha theme'] = 'Wygląd captcha';
 $lang['Comments action'] = 'Akcja wykonywana dla komentarzy';
@@ -27,3 +6,4 @@
 $lang['Moderate'] = 'Średni';
 $lang['No captcha'] = 'Brak captcha';
+
 ?>
Index: /extensions/CryptograPHP/main.inc.php
===================================================================
--- /extensions/CryptograPHP/main.inc.php	(revision 12616)
+++ /extensions/CryptograPHP/main.inc.php	(revision 12617)
@@ -3,8 +3,17 @@
 Plugin Name: Crypto Captcha
 Version: auto
-Description: Add a CryptograPHP captcha to register, comment and ContactForm pages (thanks to P@t)
+Description: Add a captcha to register, comment and ContactForm pages (thanks to P@t)
 Plugin URI: http://piwigo.org/ext/extension_view.php?eid=535
 Author: Mistic
 Author URI: http://www.strangeplanet.fr
+*/
+
+## TODO : add customization of background image
+
+/*
+Author note :
+Le plugin était appellé à l'origine CryptograPHP et utilisait la librairie CryptograPHP
+Puis il a été renommé Crypto Captcha pour plus de clareté
+La version actuelle s'appelle toujours Crypto Captcha mais utilise la librairie Securimage
 */
 
@@ -17,5 +26,7 @@
 {
   global $conf, $pwg_loaded_plugins, $page;
-  $conf['cryptographp_theme'] = explode(',', $conf['cryptographp_theme']);
+  
+  $conf['cryptographp'] = unserialize($conf['cryptographp']);
+  load_language('plugin.lang', CRYPTO_PATH);
   
   if (script_basename() == 'register')
@@ -23,18 +34,19 @@
     include(CRYPTO_PATH.'include/register.inc.php');
   }
-  else if (script_basename() == 'picture' AND $conf['cryptographp_theme'][1] != 'inactive')
+  else if (script_basename() == 'picture' and $conf['cryptographp']['comments_action'] != 'inactive')
   {
     include(CRYPTO_PATH.'include/picture.inc.php');
-  }
-  else if (
-    script_basename() == 'index' AND $conf['cryptographp_theme'][1] != 'inactive' AND 
-    isset($pwg_loaded_plugins['Comments_on_Albums']) AND 
-    $page['section'] == 'categories' AND isset($page['category'])
-  ) {
-    include(CRYPTO_PATH.'include/category.inc.php');
   }
   else if (isset($_GET['/contact'])) 
   {
     include(CRYPTO_PATH.'include/contactform.inc.php');
+  }
+  else if (
+    script_basename() == 'index' and $conf['cryptographp']['comments_action'] != 'inactive' and 
+    isset($pwg_loaded_plugins['Comments_on_Albums']) and isset($page['section']) and 
+    $page['section'] == 'categories' and isset($page['category'])
+    ) 
+  {
+    include(CRYPTO_PATH.'include/category.inc.php');
   }
 }
@@ -46,13 +58,8 @@
   function crypto_plugin_admin_menu($menu)
   {
-    global $page,$conf;
-
-    array_push(
-      $menu,
-      array(
-        'NAME' => 'CryptograPHP',
-        'URL' => get_root_url().'admin.php?page=plugin-'.basename(dirname(__FILE__))
-        )
-      );
+    array_push($menu, array(
+      'NAME' => 'Crypto Captcha',
+      'URL' => get_root_url().'admin.php?page=plugin-'.basename(dirname(__FILE__))
+      ));
     return $menu;
   }
Index: /extensions/CryptograPHP/maintain.inc.php
===================================================================
--- /extensions/CryptograPHP/maintain.inc.php	(revision 12616)
+++ /extensions/CryptograPHP/maintain.inc.php	(revision 12617)
@@ -1,10 +1,28 @@
 <?php
+define('default_config', serialize(array(
+  'comments_action' => 'reject',
+  'theme'           => 'gray',
+  'captcha_type'    => 'string',
+  'case_sensitive'  => 'false',
+  'code_length'     => 6,
+  'width'           => 120, 
+  'height'          => 40,
+  'perturbation'    => 1, 
+  'image_bg_color'  => 'ffffff', 
+  'text_color'      => '8a8a8a', 
+  'num_lines'       => 2, 
+  'line_color'      => '8a8a8a', 
+  'noise_level'     => 0.1, 
+  'noise_color'     => '8a8a8a', 
+  'ttf_file'        => 'TopSecret',
+)));
+
 function plugin_install()
 {
   global $conf;
   
-  if (!isset($conf['cryptographp_theme']))
+  if (!isset($conf['cryptographp']))
   {
-    pwg_query('INSERT INTO '.CONFIG_TABLE.' (param,value,comment) VALUES ("cryptographp_theme","cryptographp,reject","CryptograPHP config");');
+    pwg_query('INSERT INTO '.CONFIG_TABLE.' (param,value,comment) VALUES ("cryptographp",\''.default_config.'\',"CryptograPHP config");');
   }
 }
@@ -13,14 +31,18 @@
 {
   global $conf;
-  $conf['cryptographp_theme'] = explode(',', $conf['cryptographp_theme']);
   
-  if(count($conf['cryptographp_theme']) == 1)
+  if (isset($conf['cryptograph_theme']))
   {
-    pwg_query('UPDATE '.CONFIG_TABLE.' SET value = "'.$conf['cryptographp_theme'][0].',reject" WHERE param = "cryptographp_theme";');
+    pwg_query('DELETE FROM '.CONFIG_TABLE.' WHERE param="cryptographp_theme" LIMIT 1');
+  }
+  
+  if (!isset($conf['cryptograph']))
+  {
+    pwg_query('INSERT INTO '.CONFIG_TABLE.' (param,value,comment) VALUES ("cryptographp",\''.default_config.'\',"CryptograPHP config");');
   }
 }
 function plugin_uninstall()
 {
-  pwg_query('DELETE FROM '.CONFIG_TABLE.' WHERE param="cryptographp_theme" LIMIT 1');
+  pwg_query('DELETE FROM '.CONFIG_TABLE.' WHERE param="cryptographp" LIMIT 1');
 }
 
Index: /extensions/CryptograPHP/securimage/index.php
===================================================================
--- /extensions/CryptograPHP/securimage/index.php	(revision 12617)
+++ /extensions/CryptograPHP/securimage/index.php	(revision 12617)
@@ -0,0 +1,30 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | Piwigo - a PHP based photo gallery                                    |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2008-2011 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+// Recursive call
+$url = '../';
+header( 'Request-URI: '.$url );
+header( 'Content-Location: '.$url );
+header( 'Location: '.$url );
+exit();
+?>
